#ifndef CLIENT_H
#define CLIENT_H

#include <triton/client/grpc_client.h>
#include <grpcpp/grpcpp.h>
#include <triton/client/http_client.h>

namespace KyInfer {

  class Client {
  private:
      Client();
      
  public:
      static triton::client::Error CreateGrpcClient(std::unique_ptr<triton::client::InferenceServerGrpcClient>* client, const std::string& server_url, bool verbose = false, bool use_ssl = false,
        const triton::client::SslOptions& ssl_options = triton::client::SslOptions(),
        const triton::client::KeepAliveOptions& keepalive_options = triton::client::KeepAliveOptions(),
        const bool use_cached_channel = true);
      static triton::client::Error CreateHttpClient(std::unique_ptr<triton::client::InferenceServerHttpClient>* client, const std::string& server_url, bool verbose = false,
        const triton::client::HttpSslOptions& ssl_options = triton::client::HttpSslOptions());
      ~Client();
  };

}

#endif
